/* Dvojrozmerna pole - soucet a soucin matic */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define VEL 4   /* VEL - konstanta urcujici velikost pole */

typedef int MATX[VEL][VEL];   /* novy typ matice int 4x4 */

void randomize()
{
  srand( (unsigned)time( NULL ) ); /* inicializace generatoru 
                                     nahodnych cisel syst. casem */
}    

int random(int x)
{
  return (rand()*x)/RAND_MAX;
} 

int main()
{
 MATX A,B,C,D; /* deklarace 4 matic */
 int i,j,k,pom;

 /* naplneni matic A a B nahodnymi cisly */
 randomize();
 for (i=0;i<VEL;i++)
   for (j=0;j<VEL;j++)
     {
      A[i][j]=random(10)+1;
      B[i][j]=random(10)+1;
     }

 /* vypise obsah poli A a B */
 for (i=0;i<6*(VEL-1);i++) putchar(' '); printf("Pole A");
 for (i=0;i<6*VEL;i++) putchar(' '); printf("Pole B\n");
 for (i=0;i<VEL;i++)
   {
    for (j=0;j<VEL;j++)  printf("%6d", A[i][j]);
    printf("      ");
    for (j=0;j<VEL;j++)  printf("%6d", B[i][j]);
    putchar('\n');
   }

 /* soucet matic C=A+B */
 for (i=0;i<VEL;i++)
   for (j=0;j<VEL;j++)
     C[i][j]=A[i][j]+B[i][j];

 /* soucin matic D=A*B */
 for (i=0;i<VEL;i++)   /* cykl pres radky matice D */
   for (j=0;j<VEL;j++) /* vnoreny cykl pres sloupce matice D */
     {pom=0;
     for (k=0;k<VEL;k++)  /* skalarni soucin radekA*sloupecB */
       pom=pom+A[i][k]*B[k][j];
     D[i][j]=pom;
     }


 /* vypise obsah poli C a D */
 for (i=0;i<6*(VEL-1);i++) putchar(' '); printf("   A+B");
 for (i=0;i<6*VEL;i++) putchar(' '); printf("   A*B\n");
 for (i=0;i<VEL;i++)
   {
    for (j=0;j<VEL;j++)  printf("%6d", C[i][j]);
    printf("      ");
    for (j=0;j<VEL;j++)  printf("%6d", D[i][j]);
    putchar('\n');
   }
 getchar();
}
