/* Priklad na ruzne uzivatelske funkce na zpracovani retezcu */

#include <stdio.h>

int mujstrlen(char s[])
{
	int i;
	for (i=0;s[i]!=0;i++)
		;
	return i;
}

int poc_male(char s[])		// pocet malych pismen v retezci
{
 int poc=0;
 int i;
 for (i=0;s[i];i++)  /* misto s[i] by mohlo byt s[i]!=0 */
   if ((s[i]>='a')&&(s[i]<='z')) poc++;
 return poc;
}

int poc_velke(char s[])		// pocet velkych pismen v retezci
{
 int poc=0;
 int i;
 for (i=0;s[i];i++)  /* misto s[i] by mohlo byt s[i]!=0 */
   if ((s[i]>='A')&&(s[i]<='Z')) poc++;
 return poc;
}

int poc_pismen(char s[])	// pocet pismen v retezci
{
 int poc=0;
 int i;
 for (i=0;s[i];i++)  /* misto s[i] by mohlo byt s[i]!=0 */
   if ((s[i]>='a')&&(s[i]<='z')||(s[i]>='A')&&(s[i]<='Z')) poc++;
 return poc;
}

int poc_pismen2(char s[])	// pocet pismen v retezci jinak
{
    return poc_male(s)+poc_velke(s);
}    

int poc_cislic(char s[])	// pocet cislic v retezci
{
 int poc=0;
 int i;
 for (i=0;s[i];i++)  /* misto s[i] by mohlo byt s[i]!=0 */
   if ((s[i]>='0')&&(s[i]<='9')) poc++;
 return poc;
}

void copy_cis(char s1[], char s2[])	// kopiruje z retezce do retezce jen cislice
{
 int i,j;
 for (i=0,j=0;s2[i];i++)
  {
   if ((s2[i]>='0')&&(s2[i]<='9'))	// hleda ve zdrojovem retezci cislice
    {
     s1[j]=s2[i];	// nasel jsem, kopiruji
     j++;
    }
  }
 s1[j]=0;	// zakoncovaci znak
}

long mujatol(char *s)	// jako systemovy atol, ale bez osetreni nenumerickych znaku a znamenka
{
	long X=0;
	for (;*s;s++)
		X=(10*X)+((*s)-'0');
	return X;
}

int main()
{
 char znaky[120];
 char pom[100];
 long L;

 while(1)
 {
  printf("\nNeco napis: ");
  gets(znaky);
  if (!znaky[0]) return 0;		// skonci po zadani prazdneho retezce
  printf("\nZadany retezec je dlouhy %d znaku.", mujstrlen(znaky));
  printf("\nObsahuje %d pismen, z toho %d malych a %d velkych.",
	 poc_pismen(znaky), poc_male(znaky), poc_velke(znaky));
  printf("\nPocet pismen jinou funkci je %d.", poc_pismen2(znaky)); 
  copy_cis(pom, znaky);
  printf("\nPocet cislic je %d, byly zadany tyto cislice: %s.",
	  poc_cislic(znaky), pom);
  L=mujatol(pom);
  printf("\nUpraveny retezec po konverzi na cislo: %ld", L);
 }
}
