/* program vypocita odmocninu metodou tecen
   (Newtonova iteracni metoda

   x2=x1-(F(x1)/dF(x1))

   pro vypocet odmocniny plati
   F(x)=x*x - Q , kde Q je odmocnovane cislo
   pak
   x2=x1-(x1*x1-Q)/(2*x1)

*/

#include <stdio.h>
#include <math.h>

int main()
{
 double x1,x2,q;
 double eps=1E-5;
 q=2.0; /* odmocnovane cislo */

 putchar('\n'); /*odradkovani*/

 x2=q;
 printf("\n%.8f", x2);
 do {
   x1=x2;
   x2=x1-(x1*x1-q)/(2*x1);
   printf("\n%.8f", x2);
  } while (fabs(x1-x2)>eps);
     /* cyklus konci pri stanovene presnosti vypoctu */

 printf("\n%.8f odmocnina vypoctena funkci sqrt", sqrt(q));
 getchar();
}

