#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Zakladni operace
   - vypis
   - soucet prvku
   - minmum a maximum
*/

#define VEL 20   /* VEL - konstanta urcujici velikost pole */

int main()
{
 int pole1[VEL];
 int i,pom;
 long soucet;

 printf("\nVelikost pole je %d bajtu a %d polozek\n", sizeof(pole1),
	sizeof(pole1)/sizeof(int));

 srand( (unsigned)time( NULL ) ); /* inicializace generatoru
                                     nahodnych cisel syst. casem */
/* naplneni pole nahodnymi cisly */
 for (i=0;i<VEL;i++) pole1[i]=rand()-RAND_MAX/2;

 /* vypise obsah pole, 5 cisel na radku */
 for (i=0;i<VEL;i++)
   {
    printf("%7d", pole1[i]);
    if ((i+1)%5==0) putchar('\n');
   }

 /* vypocita soucet prvku pole a vypise jej na obrazovku */
 soucet=0;
 for (i=0;i<VEL;i++)
   {
    soucet=soucet+pole1[i];
   }
 printf("Soucet prvku pole je %ld.\n", soucet);

 /* prevrati poradi prvku v poli */
 for (i=0;i<VEL/2;i++)
   {
    pom=pole1[i];
    pole1[i]=pole1[VEL-1-i];
    pole1[VEL-1-i]=pom;
   }

 /* vypise znovu obsah pole, 5 cisel na radku */
 for (i=0;i<VEL;i++)
   {
    printf("%7d", pole1[i]);
    if ((i+1)%5==0) putchar('\n');
   }

 /* nalezne maximalni cislo a vypise na obrazovku */
 pom=pole1[0];
 for (i=1;i<VEL;i++)
   if (pom<pole1[i]) pom=pole1[i];
 printf("Maximalni cislo je %d.\n", pom);

 getchar();
}
