/* jednoduchy priklad na dynamickou alokaci pameti */

/* aritmateicka posloupnost */

#include <stdio.h>
#include <stdlib.h>


int main()
{
double *p1, *p2, *p3;	// deklarace 3 pointeru
						// prvni dva budou pouzity na jednoduchou promennou
						// treti bude pouzit na dynamicke pole
double *pom; // jeste pomocna promenna na cyklus
int i, n;

printf("Zadej pozadovany pocet clenu: ");
scanf("%d", &n);
if (n<1) return 2;

p1=(double*)malloc(sizeof(double)); /* alokace pameti pro jednoduchou promennou */
if (p1==NULL) return 1; /* ukonceni programu pri nedostatku pameti */
if ((p2=(double*)malloc(sizeof(double)))==NULL) return 1; /* totez zkracenym zpusobem */

p3=(double*)malloc(n*sizeof(double)); /* alokace pameti pro n-prvkove pole */
if (p3==NULL) return 1; /* opet test prideleni pameti */

printf("Zadej prvni clen a diferenci: ");
scanf("%lf %lf", p1, p2);

/* vygeneruje pozadovanou aritmetickou posloupnost */
for (pom=p3;pom<p3+n;pom++)
  {
	  if (pom==p3)
		  *pom=*p1;		// nastaveni hodnoty prvniho prvku
	  else
		  *pom=*(pom-1)+*p2;
						// dalsi prvek je predchozi plus diference
  }
/* vypise vygenerovanou posloupnost */
for (pom=p3; pom<p3+n; pom++)
  printf(" %0.2f", *pom);
puts("");
/* s dynamickym pole lze samozrejme pracovat i klasickym zpusobem */
for (i=0; i<n; i++)
  printf(" %0.2f", p3[i]);
puts("");

/* promenne p1, p2, p3 jiz nepotrebuji, uvolnim pamet */
free(p1);
free(p2);
free(p3);

while (getchar()!='\n');
getchar();
return 0;
}

