/* Priklad na dynamicke dvojrozmerne pole s pevnym poctem radku
   a s ruznymi delkami radku. 
   Modifikaci funkce main (odstraneni komentaru) program prevraci
   poradi radku v souboru nebo poradi znaku v radcich nebo oboji.
   Priklad "PREVRAT" doplnen o razeni podle abecedy
   Algoritmus razeni - bublinova metoda
*/

#include <stdio.h>
#include <stdlib.h>


typedef char *pchar;


/* Globalni promenne */
pchar text[500]; /* obsah souboru       */
int   radku;     /* pocet radku souboru */

/* Alokace pameti s osetrenim na nedostatek pameti */
void *myall(unsigned kolik)
{
 void *p;
 if ((p=malloc(kolik))==NULL)
  {
   printf("\nNedostatek pameti!\n");
   exit(1);
  }
 return p;
}

void nactisoubor()
{
 char s[120];
 FILE *fr;

 do {
    printf("\nZadej jmeno souboru: ");
    gets(s);
    if (strlen(s)==0) exit(0);
    fr=fopen(s, "r");
 } while (fr==NULL);

 for (radku=0;(radku<500)&&(!feof(fr));radku++)
   {
    if ((fgets(s, 120, fr)!=NULL)&&(strlen(s)>0))
      s[strlen(s)-1]=0;
     else
      s[0]=0;

    text[radku]=(char *)myall(strlen(s)+1);
    strcpy(text[radku], s);
   }
 fclose(fr);
}

void vypissoubor()
{
 int i;
 for (i=0;i<radku;i++)
   puts(text[i]);
}

void prevrat_radek(char *s)
{
 int  i,lg;
 char c;
 lg=strlen(s);
 for (i=0;i<lg/2;i++)
   {
    c=s[i];
    s[i]=s[lg-i-1];
    s[lg-i-1]=c;
   }
}

void prevrat_radky()
{
 int i;
 for (i=0;i<radku;i++)
   prevrat_radek(text[i]);
}

void zamen(pchar *a, pchar *b)
{
 pchar pom;

 pom=*a;
 *a=*b;
 *b=pom;

}

void trid4(pchar *A, int dim)
{
int i, j;
pchar *X;

for (i=dim;i>0;i--) {

   j=0;
   for (X=A;X<A+i-1;X++) {

     if (strcmp(*X,*(X+1))>0) {
       zamen(X, X+1);
       j=1;
       }
     }

   if (j==0) break;
  }
}


void poradi_radku()
{
 char *pom;
 int  i;
 for (i=0;i<radku/2;i++)
   {
    pom=text[i];
    text[i]=text[radku-i-1];
    text[radku-i-1]=pom;
   }
}

void main()
{
 nactisoubor();
 trid4(text, radku);
// prevrat_radky();
// poradi_radku();
 vypissoubor();
for (;getchar()!='\n';);
}
